package core.users;

import core.entities.User;
import core.repositories.UserRepository;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.orm.jpa.DataJpaTest;
import org.springframework.boot.test.autoconfigure.orm.jpa.TestEntityManager;
import org.springframework.test.annotation.DirtiesContext;
import org.springframework.test.context.junit.jupiter.SpringExtension;

import java.util.Optional;

import static org.junit.jupiter.api.Assertions.*;

@DataJpaTest
@DirtiesContext
@ExtendWith(SpringExtension.class)
public class UserRepositoryTests {

    @Autowired
    private UserRepository userRepository;

    @Autowired
    private TestEntityManager testEntityManager;

    @Test
    void test_findByUsername() {
        assertTrue(userRepository.findByUsername("FawKes100").isEmpty());
        userRepository.save(new User(1L,"FawKes100", "mail@fawkes100.de", "123456"));

        Optional<User> findResult = userRepository.findByUsername("FawKes100");
        assertTrue(findResult.isPresent());
        assertEquals(new User(1L, "FawKes100", "mail@fawkes100.de", "123456"),findResult.get());
    }
}
